<?php
if (!defined('__TYPECHO_ROOT_DIR__')) exit;
/**
 * 开启本插件后,访问该网站将需要登陆账号
 * 
 * @package 私密日记 
 * @author Jethro
 * @version 1.0.0
 * @link http://jethro.cc
 */
class PrivateDiary_Plugin implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     * 
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate()
    {
        Typecho_Plugin::factory('Widget_Archive')->beforeRender = array('PrivateDiary_Plugin', 'checkLogin');
    }
    
    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     * 
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){}
    
    /**
     * 获取插件配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
    public static function config(Typecho_Widget_Helper_Form $form){}
    
    /**
     * 个人用户的配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}
    
    /**
     * 插件实现方法
     * 检查登陆状态
     * 
     * @access public
     * @return void
     */
    public static function checkLogin()
    {
        $hasLogin = Typecho_Widget::widget('Widget_User')->hasLogin();
        if(!$hasLogin){
            Typecho_Widget::widget('Widget_Options')->to($options);
            $response = $options->response;
            $request = $options->request;
            $response->redirect($options->loginUrl.
            (0 === strpos($request->getReferer(), $options->loginUrl) ? '' :
            '?referer=' . urlencode($request->makeUriByRequest())), false);
            
        }
    }
}
